:root {
  --sidebar-width: 300px;

  --primary-color: #3498db;
  --secondary-color: #2c3e50;
  --background-color: #f5f5f5;
  --card-background: #ffffff;
  --text-color: #333333;
  --danger-color: #dc3545;
  --success-color: #28a745;

  --transition-speed: 0.3s;
}

* {
  margin: 0;
  padding: 0;
  box-sizing: border-box;
  font-family: "Roboto", sans-serif;
}

body {
  display: flex;
  align-items: flex-start;
  height: 100vh;
  background-color: var(--background-color);
  color: var(--text-color);
  overflow: hidden;
}

.sidebar {
  width: var(--sidebar-width);
  min-width: var(--sidebar-width);
  height: 100%;
  background-color: var(--card-background);
  padding: 20px;
  overflow-x: hidden;
  overflow-y: auto;
  box-shadow: 2px 0 10px rgba(0, 0, 0, 0.1);
  display: flex;
  flex-direction: column;
  gap: 16px;
}

.sidebar h1 {
  font-size: 1.5rem;
  color: var(--secondary-color);
  font-family: "Inconsolata", monospace;
}

.controls-top,
.controls-bottom {
  display: flex;
  width: 100%;
  justify-content: space-between;
}

.control-section {
  background-color: var(--background-color);
  border-radius: 8px;
  padding: 15px;
  display: flex;
  flex-direction: column;
  gap: 8px;
}

.control-section h2 {
  font-size: 1.1rem;
  color: var(--secondary-color);
  font-family: "Inconsolata", monospace;
}

.form-control {
  padding: 8px 10px;
  border: 1px solid #ddd;
  border-radius: 4px;
  font: 0.9rem;
}

.rom-loading {
  display: flex;
  flex-direction: column;
  justify-content: space-between;
  align-items: end;
}

#pause-step-btn {
  width: 90px;
  height: 37px;
}

.tooltip {
  display: inline;
  position: relative;
}
.tooltip .tooltiptext {
  visibility: hidden;
  width: 136px;
  background-color: black;
  color: #fff;
  text-align: center;
  border-radius: 6px;
  padding: 5px 0;
  position: absolute;
  z-index: 1;
  left: 50%;
  margin-left: -68px;
  font-size: 0.9rem;
  opacity: 0;
  transition: opacity var(--transition-speed);
}
.tooltip .tooltiptext:not(.bottom) {
  bottom: 100%;
}
.tooltip .tooltiptext.bottom {
  top: 100%;
}
.tooltip:hover .tooltiptext {
  visibility: visible;
  opacity: 1;
}

.cycle-rate {
  display: flex;
  flex-direction: column;
  gap: 0.5rem;
  justify-content: end;
}

.pause-step {
  display: flex;
  flex-direction: column;
  text-align: center;
  gap: 0.5rem;
}

.flags {
  display: flex;
  justify-content: space-evenly;
}

.toggle-btn {
  display: inline-flex;
  align-items: center;
  justify-content: center;
  gap: 0.5rem;
  border-radius: 4px;
  padding: 0.5rem;
  font-size: 1rem;
  background-color: var(--background-color);
  border: none;

  transition: all var(--transition-speed);
}

.toggle-btn:hover {
  background-color: var(--secondary-color) !important;
  color: var(--card-background);
}

.toggle-btn.toggle-on {
  background-color: var(--primary-color);
  color: var(--card-background);
}

.btn {
  display: inline-block;
  padding: 8px 16px;
  background-color: var(--primary-color);
  color: white;
  border: none;
  border-radius: 4px;
  cursor: pointer;
  font-size: 0.9rem;
  transition: background-color var(--transition-speed);
}

#reset-emulator {
  width: 37px;
  height: 37px;
  margin-top: auto;
  display: flex;
  justify-content: center;
  align-items: center;
  background-color: var(--danger-color);
}

#rom-picker {
  width: 100%;
  margin-right: 1.5rem;
}

#load-rom-btn {
  padding: 6px 6px;
  height: 100%;
  aspect-ratio: 1;
  display: flex;
  justify-content: center;
  align-items: center;
}
.hidden {
  display: none;
  visibility: hidden;
}

.btn:hover {
  background-color: #2980b9;
}

label {
  line-height: 1;
}

#pause-step-btn.play-mode {
  background-color: var(--primary-color);
}
#pause-step-btn {
  background-color: var(--success-color);
}

.btn-block {
  display: block;
}

.inputfile {
  width: 0.1px;
  height: 0.1px;
  opacity: 0;
  overflow: hidden;
  position: absolute;
  z-index: -1;
}

.inputfile + label {
  display: inline-block;
  padding: 8px 16px;
  font-size: 0.9rem;
  color: white;
  background-color: var(--primary-color);
  border-radius: 4px;
  display: inline-block;
  cursor: pointer;
  transition: background-color 0.2s;
}

.inputfile:focus + label,
.inputfile + label:hover {
  background-color: #2980b9;
}

.switch-container {
  display: flex;
  justify-content: space-between;
  align-items: center;
  margin-bottom: 10px;
}

.switch {
  position: relative;
  display: inline-block;
  width: 44px;
  height: 24px;
}

.switch input {
  opacity: 0;
  width: 0;
  height: 0;
}

.slider {
  position: absolute;
  cursor: pointer;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  background-color: #ccc;
  transition: 0.4s;
  border-radius: 34px;
}

.slider:before {
  position: absolute;
  content: "";
  height: 18px;
  width: 18px;
  left: 3px;
  bottom: 3px;
  background-color: white;
  transition: 0.4s;
  border-radius: 50%;
}

input:checked + .slider {
  background-color: var(--primary-color);
}

input:checked + .slider:before {
  transform: translateX(20px);
}

.emulator-container {
  min-width: 670px;
  min-height: 466px;

  width: calc(max(466px, 65vh) / (466 / 670));

  max-height: 100vh;
  max-width: calc(100vh / (466 / 670));

  overflow: hidden;
  aspect-ratio: 670 / 466;
  resize: horizontal;
}

iframe {
  width: 100%;
  height: 100%;

  box-shadow: 0 4px 15px rgba(0, 0, 0, 0.1);
}
